#ifndef _DSCP__H_
#define _DSCP__H_

#include <string>
#include <vector>


#define SIMPLE_TYPE		0
#define FUNC_TYPE		1
#define ARR_ONE_TYPE	2
#define ARR_TWO_TYPE	3
enum BasicT { CHAR, INT, CHARSTAR, INTSTAR, ARR1D, ARR2D, SIMPLE};
typedef std::string STRING;
typedef std::vector<BasicT> ARGVECT;

class DSCP
{
public:
	DSCP(STRING name, BasicT type){this->name = name; this->type = type;}
	DSCP(){}
	virtual int gettype() = 0;
	virtual const STRING & getname() = 0;
	virtual const STRING & getcode() = 0;
	virtual const BasicT & getmytype() = 0;

	STRING name;
	BasicT type;
	STRING code;
};


class Simple : public DSCP
{
public:
	Simple(STRING name, STRING code, BasicT type) : DSCP(name ,type) {this->code = code;}
	int gettype(){return SIMPLE_TYPE;}
	const STRING & getname(){return name;}
	const STRING & getcode(){return code;}
	const BasicT & getmytype(){return type;}
};

class OneDArr : public DSCP
{
public:
	OneDArr(STRING name, STRING code, BasicT type) : DSCP(name, type) {this->code = code;}
	int gettype(){return ARR_ONE_TYPE;}
	const STRING & getname(){return name;}
	const STRING & getcode(){return code;}
	const BasicT & getmytype(){return type;}
};

class TwoDArr : public DSCP
{
public:
	TwoDArr(STRING name, STRING code, int size, BasicT type) : DSCP(name, type) {this->code = code; this->size = size;}
	int gettype(){return ARR_TWO_TYPE;}
	const STRING & getname(){return name;}
	const STRING & getcode(){return code;}
	int getsize(){return size;}
	const BasicT & getmytype(){return type;}
private:
	int size;
};







#endif
